//---------------------------------------------------------------------------//
//
//	Secret Garden - Character Select
//
//	Date : 2008/05/06
//
//---------------------------------------------------------------------------//

#include "CharacterSelect.h"
#include "GameMain.h"

CCharacterSelect::CCharacterSelect()
{
}

CCharacterSelect::~CCharacterSelect()
{
}

bool CCharacterSelect::Init(CGameStateTranslator* pTranslator)

{
	m_pSelectLogo = new CTexture;
	m_pSelectLogo->Load(_T("texture\\selectcharacter.png"));

	
	m_pPinkSelect = new CTexture;
	m_pPinkSelect->Load(_T("texture\\select1.png"));

	m_pCatSelect = new CTexture;
	m_pCatSelect->Load(_T("texture\\select2.png"));

	m_pPrincessSelect = new CTexture;
	m_pPrincessSelect->Load(_T("texture\\select3.png"));


	m_pPinkSelectS = new CTexture;
	m_pPinkSelectS->Load(_T("texture\\select1_2.png"));

	m_pCatSelectS = new CTexture;
	m_pCatSelectS->Load(_T("texture\\select2_2.png"));

	m_pPrincessSelectS = new CTexture;
	m_pPrincessSelectS->Load(_T("texture\\select3_2.png"));

	
	return true;
}

void CCharacterSelect::Release()
{
	SAFE_DELETE(m_pSelectLogo);
	SAFE_DELETE(m_pPinkSelect);
	SAFE_DELETE(m_pCatSelect);
	SAFE_DELETE(m_pPrincessSelect);
	SAFE_DELETE(m_pPinkSelectS);
	SAFE_DELETE(m_pCatSelectS);
	SAFE_DELETE(m_pPrincessSelectS);
}

int CCharacterSelect::Update()
{
	DIMGetMousePos(m_x, m_y);

	selected=0;

	if (m_y>=104 && m_y<=404)
	{
		if(m_x>=52 && m_x<=242)
		{
			selected=1;
		}
		else if(m_x>=302 && m_x<=492)
		{
			selected=2;
		}
		else if(m_x>=552 && m_x<=742)
		{
			selected=3;
		}
	}

	if (DIMPress(DIM_LEFT) && selected != 0)
	{
		m_pTranslator = new CGameMainTranslator;
		CGameMainTranslator* pTrans = static_cast<CGameMainTranslator*>(m_pTranslator);
		pTrans->m_nPrevState = CGameState::SELECT_CHARACTER;
		pTrans->m_nSelectedCharacter = selected;
		pTrans->Translate();
	}
	else if (DIMPress(DIM_RIGHT))
	{
		m_pTranslator = new CGameStateTranslator;
		m_pTranslator->m_nPrevState = CGameState::SELECT_CHARACTER;
		m_pTranslator->m_nNextState = CGameState::GAME_MENU;
		m_pTranslator->Translate();
	}

	return true;
}

void CCharacterSelect::Render(CRenderer* pRenderer)
{
	pRenderer->BeginDrawTexture(800,600);

	pRenderer->DrawTexture(m_pSelectLogo, 144, 36);


	if(selected==0)
	{
		pRenderer->DrawTexture(m_pPinkSelectS, 22,104);
		pRenderer->DrawTexture(m_pCatSelectS, 272, 104);
		pRenderer->DrawTexture(m_pPrincessSelectS, 522,104);

	}

	if(selected==1)
	{
		pRenderer->DrawTexture(m_pPinkSelect, 22,104);
		pRenderer->DrawTexture(m_pCatSelectS, 272, 104);
		pRenderer->DrawTexture(m_pPrincessSelectS, 522,104);

	}

	if(selected==2)
	{
		pRenderer->DrawTexture(m_pPinkSelectS, 22,104);
		pRenderer->DrawTexture(m_pCatSelect, 272, 104);
		pRenderer->DrawTexture(m_pPrincessSelectS, 522,104);
	}

	if(selected==3)
	{
		pRenderer->DrawTexture(m_pPinkSelectS, 22,104);
		pRenderer->DrawTexture(m_pCatSelectS, 272, 104);
		pRenderer->DrawTexture(m_pPrincessSelect, 522,104);

	}

	pRenderer->EndDrawTexture();
}