//---------------------------------------------------------------------------//
//
//	Secret Garden - Game Menu
//
//	Date : 2008/05/27
//
//---------------------------------------------------------------------------//

#include "GameMenu.h"
//#include "CharacterSelect.h"
//#include "GameMain.h"
//#include "GameResult.h"

//---------------------------------------------------------------------------//
//	CGameMenu Class
//---------------------------------------------------------------------------//
CGameMenu::CGameMenu()
{
}

CGameMenu::~CGameMenu()
{
}

bool CGameMenu::Init(CGameStateTranslator* pTranslator)
{
	title = new CTexture;
	title->Load(_T("texture\\gamelogo.png"));

	// menu
	m_pGameStart = new CTexture;
	m_pGameStart->Load(_T("texture\\menu1.png"));

	m_pScore = new CTexture;
	m_pScore->Load(_T("texture\\menu2.png"));

	m_pGameExit = new CTexture;
	m_pGameExit->Load(_T("texture\\menu3.png"));

	m_pStaff = new CTexture;
	m_pStaff->Load(_T("texture\\menu4.png"));

	// select  menu

	m_pGameStartS = new CTexture;
	m_pGameStartS->Load(_T("texture\\menu1_2.png"));

	m_pScoreS = new CTexture;
	m_pScoreS->Load(_T("texture\\menu2_2.png"));

	m_pGameExitS = new CTexture;
	m_pGameExitS->Load(_T("texture\\menu3_2.png"));

	m_pStaffS = new CTexture;
	m_pStaffS->Load(_T("texture\\menu4_2.png"));

	m_x = m_y = 0;

	return true;
}

void CGameMenu::Release()
{
	SAFE_DELETE(title);
	SAFE_DELETE(m_pGameStart);
	SAFE_DELETE(m_pScore);
	SAFE_DELETE(m_pGameExit);
	SAFE_DELETE(m_pStaff);
	SAFE_DELETE(m_pGameStartS);
	SAFE_DELETE(m_pScoreS);
	SAFE_DELETE(m_pGameExitS);
	SAFE_DELETE(m_pStaffS);
}

int CGameMenu::Update()
{
	DIMGetMousePos(m_x, m_y);

	selected=0;

	if(m_x>=303 && m_x<=503)
	{
		if(m_y>=352 && m_y<=392) // Game Start
		{
			selected=1;
			if (DIMPress(DIM_LEFT))
			{
				m_pTranslator = new CGameStateTranslator;
				m_pTranslator->m_nPrevState = CGameState::GAME_MENU;
				m_pTranslator->m_nNextState = CGameState::SELECT_CHARACTER;
				m_pTranslator->Translate();
			}
		}
		else if(m_y>=412 && m_y<=452) // Score
		{
			selected=2;
			if (DIMPress(DIM_LEFT))
			{
			}
		}
		else if(m_y>=472 && m_y<=512) // Staff
		{
			selected=3;
			if (DIMPress(DIM_LEFT))
			{
				m_pTranslator = new CGameStateTranslator;
				m_pTranslator->m_nPrevState = CGameState::GAME_MENU;
				m_pTranslator->m_nNextState = CGameState::STAFF;
				m_pTranslator->Translate();
			}
		}
		else if(m_y>=532 && m_y<=572) // EXIT
		{
			selected=4;
			if (DIMPress(DIM_LEFT))
			{
				m_pTranslator = new CGameStateTranslator;
				m_pTranslator->m_nPrevState = CGameState::GAME_MENU;
				m_pTranslator->m_nNextState = CGameState::EXIT;
				m_pTranslator->Translate();
			}
		}
	}
	return true;
}

void CGameMenu::Render(CRenderer* pRenderer)
{
	pRenderer->BeginDrawTexture(800,600);

	pRenderer->DrawTexture(title, 150, -90);

	if(selected==0)
	{
		pRenderer->DrawTexture(m_pGameStart, 275, 340);
		pRenderer->DrawTexture(m_pScore, 275,400);
		pRenderer->DrawTexture(m_pStaff, 275,460);
		pRenderer->DrawTexture(m_pGameExit, 275,520);
	}
	else if(selected==1)
	{
		pRenderer->DrawTexture(m_pGameStartS, 275, 340);
		pRenderer->DrawTexture(m_pScore, 275,400);
		pRenderer->DrawTexture(m_pStaff, 275,460);
		pRenderer->DrawTexture(m_pGameExit, 275,520);
	}
	else if(selected==2)
	{
		pRenderer->DrawTexture(m_pGameStart, 275, 340);
		pRenderer->DrawTexture(m_pScoreS, 275,400);
		pRenderer->DrawTexture(m_pStaff, 275,460);
		pRenderer->DrawTexture(m_pGameExit, 275,520);
	}
	else if(selected==3)
	{
		pRenderer->DrawTexture(m_pGameStart, 275, 340);
		pRenderer->DrawTexture(m_pScore, 275,400);
		pRenderer->DrawTexture(m_pStaffS, 275,460);
		pRenderer->DrawTexture(m_pGameExit, 275,520);
	}
	else if(selected==4)
	{
		pRenderer->DrawTexture(m_pGameStart, 275, 340);
		pRenderer->DrawTexture(m_pScore, 275,400);
		pRenderer->DrawTexture(m_pStaff, 275,460);
		pRenderer->DrawTexture(m_pGameExitS, 275,520);
	}

	pRenderer->EndDrawTexture();
}