//---------------------------------------------------------------------------//
//
//	Secret Garden - Map
//
//	Date : 2008/05/25
//
//---------------------------------------------------------------------------//

#include "Map.h"
#include <stdio.h>

//! . DWORD dwColor
short sRed = 0xfffff888;
short sYellow = 0xfffff222;
short sBlue = 0xfffff222;
short sBlack = 0xfffff222;

CMap::CMap()
{
	m_stageNumber = 1;
	m_totalStage = 3;
}
CMap::~CMap()
{
}

// -------------------------------------------------
bool CMap::Init()
{
	for (int i=0; i<8; i++)
	{
		for (int j=0; j<12; j++)
			m_pColRect[i][j] = new CollisionRect;
	}

	switch (m_stageNumber)
	{
		case 1 :
			m_pSzFileName = "stage1.dat";
			break;
		case 2 :
			m_pSzFileName = "stage2.dat";
			break;
		case 3 :
			m_pSzFileName = "stage3.dat";
			break;
		default :
			break;
	}
	
	FILE *fp = fopen(m_pSzFileName,"rt");
	if (fp == NULL)
	{
	}
	//Layer1
	fscanf(fp,"%s",m_szBuff);
	if(!(strcmp("layer1",m_szBuff))){
		for(int y=0;y<8;y++)
		{
			for(int x=0;x<12;x++)
			{
				fscanf(fp,"%d",&m_number);
				m_Layer1[y][x] = m_number;
			}
		}
	}

	//Layer2
	fscanf(fp,"%s",m_szBuff);
	if(!(strcmp("layer2",m_szBuff))){
		for(int y=0;y<8;y++)
		{
			for(int x=0;x<12;x++)
			{
				fscanf(fp,"%d",&m_number);
				m_Layer2[y][x] = m_number;
				m_pColRect[y][x]->tilenum = m_number;
			}
		}
	}

	//Layer3
	fscanf(fp,"%s",m_szBuff);
	if(!(strcmp("layer3",m_szBuff))){
		for(int y=0;y<8;y++)
		{
			for(int x=0;x<12;x++)
			{
				fscanf(fp,"%d",&m_number);
				m_Layer3[y][x] = m_number;
			}
		}
	}
	fclose(fp);

	//!Tile 0-10
	m_pTexture[BACKTEX] = new CTexture;		//ٴ 0
	m_pTexture[BACKTEX]->Load(_T("texture\\Stone Block.png")); 

	//!Block 11-30
	m_pTexture[DOOROPEN] = new CTexture;;	// 11
	m_pTexture[DOOROPEN]->Load(_T("texture\\Selector.png"));
	m_pTexture[DOORCLOSE] = new CTexture;;	// 12
	m_pTexture[DOORCLOSE]->Load(_T("texture\\Chest Closed.png"));
	m_pTexture[ROCK] = new CTexture;;		// 13
	m_pTexture[ROCK]->Load(_T("texture\\Rock.png"));
	m_pTexture[ROCKMOVE] = new CTexture;;	//̴µ 14
	m_pTexture[ROCKMOVE]->Load(_T("texture\\Rock.png"));
	m_pTexture[TREESHORT] = new CTexture;;	// 15
	m_pTexture[TREESHORT]->Load(_T("texture\\Tree Short.png"));
	m_pTexture[TREEBIG] = new CTexture;;	//ū 16
	m_pTexture[TREEBIG]->Load(_T("texture\\Tree Tall.png"));	

	//!Item 31-34
	m_pTexture[KEY] = new CTexture;			//Ű 31
	m_pTexture[KEY]->Load(_T("texture\\Key.png"));
	m_pTexture[GEMORANGE] = new CTexture;;	// 32
	m_pTexture[GEMORANGE]->Load(_T("texture\\Gem Orange.png"));
	m_pTexture[GEMGREEN] = new CTexture;;	// 33
	m_pTexture[GEMGREEN]->Load(_T("texture\\Gem Green.png"));
	m_pTexture[GEMBLUE] = new CTexture;;	//Ķ 34
	m_pTexture[GEMBLUE]->Load(_T("texture\\Gem Blue.png"));

	m_doorState = false;
	m_rockMoveValueX = 0;
	m_rockMoveValueY = 0;

	return true;
}

void CMap::Release()
{

	for(int i=0;i<40;i++){
		SAFE_DELETE(m_pTexture[i]);
	}
	
	//! 
	for (int i=0; i<8; i++)
		delete[] m_pColRect[i];
}

//! 浹  ġ  Ӹ 
int CMap::Update()
{
	for (int y=0; y<8; y++)
	{
		for (int x=0; x<12; x++)
		{
			m_pColRect[y][x]->x1 = x*128;		
			m_pColRect[y][x]->x2 = x*128 + 101;	
			m_pColRect[y][x]->y1 = y*128 + 20;	
			m_pColRect[y][x]->y2 = y*128 + 128;	

			if (m_doorState==true && m_Layer2[y][x]==DOORCLOSE)
				m_Layer2[y][x] = DOOROPEN;
		}
	}
	return true;
}

//! ̾ Ÿ  ׷
void CMap::Render(int layerNumber, CRenderer* pRenderer)
{
	//! Layer Number ־ָ ΰ  Ÿ   ִ.
	switch(layerNumber)
	{
	case 1:
		//! layer 1	: ع()
		for (int y=0; y<8; y++)
		{
			for (int x=0; x<12; x++)
			{
				switch(m_Layer1[y][x])
				{
				case BACKTEX:
					pRenderer->DrawTexture(m_pTexture[BACKTEX], 32+x*128, y*128);
					break;
				default:
					break;
				}
			}
		}
		break;
	case 2:
		//! layer 2 : Movement Object : Ű,,,
		for (int y=0; y<8; y++)
		{
			for (int x=0; x<12; x++)
			{
				switch(m_Layer2[y][x])
				{
				case DOOROPEN:
					pRenderer->DrawTexture(m_pTexture[DOOROPEN], 32+x*128, y*128-58);
					break;
				case DOORCLOSE:
					pRenderer->DrawTexture(m_pTexture[DOORCLOSE],32+x*128,y*128-58 );
					break;
				case ROCK:
					pRenderer->DrawTexture(m_pTexture[ROCK], 32+x*128, y*128-58);
					break;
				case ROCKMOVE:
					if (m_beforeX == x && m_beforeY == y)
					{
						pRenderer->DrawTexture(m_pTexture[ROCKMOVE], 32+x*128+m_rockMoveValueX, y*128-58+m_rockMoveValueY,sRed);

					}
					else
					{
						pRenderer->DrawTexture(m_pTexture[ROCKMOVE], 32+x*128, y*128-58,sRed);
					}
					break;
				case KEY :
					pRenderer->DrawTexture(m_pTexture[KEY], 32+x*128, y*128-32);
					break;
				case GEMORANGE:
					pRenderer->DrawTexture(m_pTexture[GEMORANGE], 32+x*128, y*128-58);
					break;
				case GEMGREEN:
					pRenderer->DrawTexture(m_pTexture[GEMGREEN], 32+x*128, y*128-58);
					break;
				case GEMBLUE:
					pRenderer->DrawTexture(m_pTexture[GEMBLUE], 32+x*128, y*128-58);
					break;
				default:
					break;
				}
			}
		}
		break;
		case 3:
			//! Layer3
		for (int y=0; y<8; y++)
		{
			for (int x=0; x<12; x++)
			{
				switch(m_Layer3[y][x])
				{
				case TREESHORT:
					pRenderer->DrawTexture(m_pTexture[TREESHORT], 32+x*128, y*128-58);
					break;
				case TREEBIG:
					pRenderer->DrawTexture(m_pTexture[TREEBIG], 32+x*128, y*128-58);
					break;
				default:
					break;
				}
			}
		}
			break;
		default:
			break;
		}
}

// ==================================================================
//! ̴  Ÿ  (false : no move, true : move)
bool CMap::EndMotion()
{
	if (m_rockMoveValueX % 128 == 0 && m_rockMoveValueY % 128 == 0)
	{
		m_rockMoveValueX = 0;
		m_rockMoveValueY = 0;
		return true;
	}
	return false;
}

//!  Ÿ ε巴 ̱
void CMap::RockMoveMotion(int _i,int _j,int _direction)
{
	switch (_direction)
	{
		case LEFT :
			m_rockMoveValueX-=8;
			break;
		case RIGHT :
			m_rockMoveValueX+=8;
			break;
		case UP :
			m_rockMoveValueY-=8;
			break;
		case DOWN :
			m_rockMoveValueY+=8;
			break;
		default :
			break;
	}

	m_beforeY = _i;
	m_beforeX = _j;

}

//!  stage Ѿ
void CMap::NextStage()
{
	if (m_stageNumber == m_totalStage)	// 
	{
		m_stageNumber = 1;
		return;
	}

	m_stageNumber++;
}

// ==================================================================
//!   Լ
//! Ÿ ǥ  
void CMap::SetTile(int layernum, int i, int j, int tilenum)
{
	switch(layernum)
	{
		case 1 :
			m_Layer1[i][j] = tilenum;
			break;
		case 2 :
			m_Layer2[i][j] = tilenum;
			break;
		case 3 :
			m_Layer3[i][j] = tilenum;
			break;
		default :
			break;
	}
}

//!  
void CMap::SetDoorState(bool _state)
{
	m_doorState = _state;
}


// ==================================================================
//!   Լ
//!  ȣ
int CMap::GetStageNumber()
{
	return m_stageNumber;
}

//! Ÿǥ 
int CMap::GetTile(int layernum, int i, int j)
{
	switch(layernum)
	{
		case 1 :
			return m_Layer1[i][j];
			break;
		case 2 :
			return m_Layer2[i][j];
			break;
		case 3 :
			return m_Layer3[i][j];
			break;
		default :
			break;
	}
}

//! 浹
CollisionRect* CMap::GetColRect(int layernum, int i, int j)
{
	return m_pColRect[i][j];		
}
