//---------------------------------------------------------------------------//
//
//	Secret Garden - Main
//
//	Date : 2008/05/02
//
//---------------------------------------------------------------------------//

#pragma once

#include "framework.h"
#include "texture.h"

//# 
const int TOTALSTAGE = 3;
const int MAP_WIDTH = 12;
const int MAP_HEIGHT = 8;
//# end

struct CollisionRect
{
	int x1, x2;
	int y1, y2;
	int tilenum;
};

class CSecretGarden;

class CSecretGardenConfig : public CFrameworkConfig
{
private:

public:
};

class CGameStateData
{
public:
};

class CGameStateTranslator
{
public:
	int		m_nPrevState;
	int		m_nNextState;

	bool	m_bTranslate;

public:
	CGameStateTranslator();
	virtual ~CGameStateTranslator();

	//!  · ̽ѵ ȴٰ Ѵ.
	bool Translate();
	//!  ѵ Ǵ θ ˾ƿ´.
	bool IsTranslate();
};

class CGameState
{
public:
	enum 
	{
		NONE = 0,
		TITLE,
		SELECT_CHARACTER,
		GAME_MAIN,
		GAME_RESULT,
		GAME_MENU,
		SCORE,
		STAFF,
		EXIT,
	};

protected:
	CGameStateTranslator*	m_pTranslator;

public:
	CGameState();
	virtual ~CGameState();

	virtual bool Init(CGameStateTranslator* pTranslator);
	virtual void Release();
	virtual int Update();
	virtual void Render(CRenderer* pRenderer);

private:
	CGameStateTranslator* GetTranslator();

	friend class CSecretGarden;
};

class CSecretGarden : public CFramework
{
private:
	CGameState*	m_pState;


public:
	CSecretGarden();
	~CSecretGarden();

	//! ҽ εѴ.
	bool Initialize();
	//! ε ҽ Ѵ.
	void FinalRelease();

	bool Init(CFrameworkConfig* pConfig); // override

	void Release(); // override

	//! 1ʸ  Ӹŭ Ʈ Ѵ.
	int Update(); // override
	//! Ʈ ͸ ȭ鿡 Ѵ. Ʈ ϰ  ð  ȴ.
	void Render(); // override

private:
	void SetState(int nGameState, CGameStateTranslator* pTranslator);
};