//---------------------------------------------------------------------------//
//
//	Graphics - Texture
//
//	Date : 2008/04/10
//
//---------------------------------------------------------------------------//

#pragma once

#include "renderer_interface.h"

#define DEFAULT_COLOR_KEY		0xffff00ff

//! ؽ Ŭ
class GRAPHICS_API CTexture : public IRenderDevice
{
private:
	LPDIRECT3DTEXTURE9	m_pTexture;		//!< D3D ؽ ü
	tstring				m_strFilename;	//!< ؽ 
	UINT				m_nMipLevels;	//!< Ӹ 
	D3DPOOL				m_Pool;			//!< ؽİ D3D   Ǵ°.
	D3DFORMAT			m_Format;		//!< ؽ 
	DWORD				m_dwFilter;		//!< ؽ εҶ ͸ 
	DWORD				m_dwMipFilter;	//!< ؽ Ӹ εҶ ͸ 
	DWORD				m_dwTransparent;//!< ؽ ĮŰ
	UINT				m_nWidth;		//!< ؽ 
	UINT				m_nHeight;		//!< ؽ 

public:
	CTexture();
	~CTexture();

	//! ̽ ϴ  ؽĸ Ѵ.
	bool SetTexture(DWORD dwStage=0);
	//! D3D ؽ ü ͸ ´.
	LPDIRECT3DTEXTURE9 GetTexture();

	//! ؽĸ ־ ũ⿡ ° Ѵ.
	bool Create(UINT nWidth, UINT nHeight, D3DFORMAT Format, UINT nMipLevels=0, D3DPOOL Pool=D3DPOOL_MANAGED);
	//! ĸ ־ ũ⿡ ° Ѵ.
	bool Create(UINT nWidth, UINT nHeight, DWORD dwUsage = D3DUSAGE_AUTOGENMIPMAP, D3DFORMAT Format = D3DFMT_A8R8G8B8, UINT nMipLevels=0, D3DPOOL Pool=D3DPOOL_MANAGED);
	//! ؽĸ ϰų ϱ Ѵ.
	bool Lock(D3DLOCKED_RECT& Locked, bool bReadOnly=false);
	//!  ؽ  Ǭ. (Ӹ  Ӹʵ Ѵ.)
	void Unlock();

	//! ؽĸ εѴ.
	/*!
		@param strFilename [in] ؽ  ̸ ( )
		@param nMipLevels [in]  Ӹ  (Ʈ Ӹ   D3DX_DEFAULT)
		@param Pool [in] ؽİ ġ ޸ Ǯ (Ʈ D3D   D3DPOOL_MANAGED)
		@param Format [in] ؽ ؼ  (Ʈ ۿ  D3DFMT_UNKNOWN)
		@param dwTransparent [in] ؽ ĮŰ (Ʈ  ǵ DEFAULT_COLOR_KEY)
		@return ؽ ε  
	*/
	bool Load(const tstring& strFilename, UINT nMipLevels=0, 
		D3DFORMAT Format=D3DFMT_UNKNOWN, D3DPOOL Pool=D3DPOOL_MANAGED,
		DWORD dwFilter=D3DX_DEFAULT, DWORD dwMipFilter=D3DX_DEFAULT, DWORD dwTransparent=DEFAULT_COLOR_KEY);

	//! ؽĸ Ѵ. Ҹڿ ȣǸ ҽ Ǯ ۷ īͰ 0 ɶ ȣȴ. (override)
	void Release();
	//! ؽİ ֹ߼ ޸𸮿 ö  ϱ   Ѵ. (override)
	void Disable();
	//! ؽİ ֹ߼ ޸𸮿 ö  ϱ  ٽ εѴ. (override)
	void Restore();

	inline const tstring& GetTextureFileName() const;
	inline int GetWidth() const;
	inline int GetHeight() const;
	inline D3DFORMAT GetFormat() const;

private:
	bool UpdateInfo();
};

const tstring& CTexture::GetTextureFileName() const
{
	ASSERT(!m_strFilename.empty());
	return m_strFilename;
}

int CTexture::GetWidth() const
{
	ASSERT(m_pTexture);
	return m_nWidth;
}

int CTexture::GetHeight() const
{
	ASSERT(m_pTexture);
	return m_nHeight;
}

D3DFORMAT CTexture::GetFormat() const
{
	ASSERT(m_pTexture);
	return m_Format;
}